<?php
/**
 * @fileID: $Id: toolset.php 7767 2012-01-26 09:04:54Z kostya $
 * @changedDate: $LastChangedDate: 2012-01-26 16:04:54 +0700 (Чт, 26 янв 2012) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Core plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgJoomsuite_contentToolset extends JPlugin
{
	function plgJoomsuite_contentToolset( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onToolsGetIcons()
	{
		$db = &JFactory::getDBO();

		$sql = "SELECT count(*) FROM #__js_res_sef";
		$db->setQuery($sql);
		$res = (int)$db->loadResult();

		$i = 0; 
		
		$i++;
		$icon[$i]->label = JText::_('Clean SEF Links')."<br>({$res})";
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/sef_clean.png';
		$icon[$i]->description = JText::_('As it is known SEF slow down site speed. To optimize our components we store(cache) SEF links in DB thus speed up component work. If you changed SEF component or configuration or just want to reset SEF URLs on the site you can clean this table with this tool.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 1;
		$icon[$i]->height = 250;


		$sql = "SELECT count(*) FROM #__js_res_cache";
		$db->setQuery($sql);
		$res = (int)$db->loadResult();
		$i++;
		$icon[$i]->label = JText::_('Clean Cache')."<br>({$res})";
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/clean_cache.png';
		$icon[$i]->description = JText::_('To speed up resources it uses own cache system. If you want clean cache you can use this tool.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 4;
		$icon[$i]->height = 350;

		$sql = "SELECT 	count(*) FROM #__session";
		$db->setQuery($sql);
		$res = (int)$db->loadResult();
		$i++;
		$icon[$i]->label = JText::_('Clean Sessions').'<br>('.$res.')';
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/clean_cache.png';
		$icon[$i]->description = JText::_('Will delete all active sessions including your current session.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 6;
		$icon[$i]->height = 400;

		$i++;
		$icon[$i]->label = JText::_('DB Tool');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/db.png';
		$icon[$i]->description = JText::_('Some important operations with tables');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 8;
		$icon[$i]->height = 600;
		
		$i++;
		$icon[$i]->label = JText::_('Move/Delete User');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/move_user.png';
		$icon[$i]->description = JText::_('If you acidently deleted some user or you want to move rocords, files, activity, ... t other user run this tool');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 2;
		$icon[$i]->height = 600;

		$i++;
		$icon[$i]->label = JText::_('Pack Section');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/pack_section.png';
		$icon[$i]->description = JText::_('Create redistributable installation package with one of the Resources section. <p>This tool will pack <b>section/categories</b>, all related <b>types</b>, all <b>articles</b>, <b>templates</b>, <b>files</b>, <b>users</b> if needed into Joomla installation ZIP package. <p>It is great way to share your section or redistribute configuration. For example, you can create gallery section. Configure custom templates, add demo content, set all settings and pack it. User who install it will get ready Gallery section. One will just need to create link to that section in menu.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 3;
		$icon[$i]->height = 600;

		$i++;
		$icon[$i]->label = JText::_('Calculator');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/calculator.png';
		$icon[$i]->description = JText::_('Recalculate number of records in categories, number of votes, favorites of the records, and other numbers ...');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 5;
		$icon[$i]->height = 300;


		$i++;
		$icon[$i]->label = JText::_('Archive/Unarchive');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/archive.png';
		$icon[$i]->description = JText::_('Archive/Unarchive articles based on creation date.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 7;
		$icon[$i]->height = 300;
		
		$i++;
		$icon[$i]->label = JText::_('File Relocation');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/relocate.png';
		$icon[$i]->description = JText::_('Migrate fields file, picture, video, audio to version 2.0 and above.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 9;
		$icon[$i]->height = 200;
		
		$i++;
		$icon[$i]->label = JText::_('1.5.8 to 1.5.9+ Migration');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/migrate.png';
		$icon[$i]->description = JText::_('Help to migrate from resources version 1.5.8 to higher one. Also re-validate all records with empty fieldsdata needed for search.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 11;
		$icon[$i]->height = 250;
		
		$i++;
		$icon[$i]->label = JText::_('Revalidate fields data for search');
		$icon[$i]->icon = 'plugins/joomsuite_content/toolset/icons/calculator.png';
		$icon[$i]->description = JText::_('This will re-validate all fields data in records. You must do it if you turn on/off searchable parametr in some field.');
		$icon[$i]->name = 'toolset';
		$icon[$i]->id = 12;
		$icon[$i]->height = 300;

		return  $icon;
	}

	function onToolGetForm($form, $name, $id)
	{
		if($name != 'toolset') return;

		$xml = new JParameter('', JPATH_PLUGINS.DS.'joomsuite_content'.DS.'toolset.xml');

		switch ($id)
		{
			// clean sef tool
			case 5:
				$form = $xml->render('params', 'calculator_parameters');
				break;
			case 7:
				$form = $xml->render('params', 'archive_parameters');
				break;
			case 8:
				$form = $xml->render('params', 'db_tools');
				break;
			case 9:
				$form = $xml->render('params', 'migrate');
				break;
			case 6:
				$form = '<h3>'.JText::_('Delete Sessions Of Following Groups').'</h3>';
				$form .= $xml->render('params', 'clean_sessions_parameters');
				break;
			case 1:
				$form = $xml->render('params', 'clean_sef_parameters');
				break;
					
			case 2:
				$form = '<p>'.JText::_('To use <b>MOVE</b> and <b>MERGE</b> you have to set <b>Move to user ID</b> parameter!').'</p>';
				$form .= $xml->render('params', 'move_user_parameters');
				break;

			case 3:
				//if(RES_MODE)
				//$form = $xml->render('params', 'pack_section_parameters_4');
				//else
				//$form = $xml->render('params', 'pack_section_parameters_3');
				JError::raiseWarning(400, Jtext::_('Alfa version. Please be do not install packs on live sites.'));
				$form = '<b>';
				$form .= JHTML::link('http://www.mightyextensions.com/downloads/redistributable-cck-section-packs', JText::_('Search Community Packs'), array('target' => '_blank')). ' | ';
				$form .= JHTML::link('http://www.mightyextensions.com/knowledge-base/joomla-tutorials/item/developer-center/99-resources-cck/21996-understanding-section-pack', JText::_('Share Your Pack With Community'), array('target' => '_blank')).'</b></b><br /><br />';
				$form .= $xml->render('params', 'pack_section_parameters');
				$form .= '<fieldset><legend>'.JText::_('Pack Templates').'</legend>'.$xml->render('params', 'pack_section_parameters_2').'</fieldset>';
				$form .= "<h1>Read To Understand</h1>
<h3>What Is Pack</h3>
<p>This tool will create Joomla Installation package that will include your section categories, 
all related types and fields, content if you whish and all content related things like pictures, votes, ...
<p>This allow you create and distribute different Resources configurations. For example ready to use 
multi user blog system or Car catalog, ...
<h3>Pack Key</h3>
<p>Every pack have it is hidden uniquie key. That allow pack update. It means that if you create pack 
version 1.0 and then 1.1 the last pack will be rather update for those who already installed pack 1.0. It means it will 
not create new section but update section that was created on installation of pack 1.0.
<p>Every key is created using Site name, Section ID, and pack name. It means if you change any of those values, 
installation package will create new section rather then update already created.
<p>So follow simple rule. Do not change your site name, try to create uniquie and do not change your 
pack name.
<h3>Multi Section Pack</h3>
<p> It is strongly not recomended that you use multi section pack. There is only one reason for multi pack: 
related records. In other cases NEVER USE MULTI PACK 
<p> Multisection pack available only in Advanced mode ON.

<h3>Pack templates</h3>
<p> If you made changes or you use custom template with ifields, you mast include template into package. 
Please do not pack templates you did not change and use from template pack. Because included templates are 
renamed and it will create copies of the same templates. 
";
				break;

			case 4:
				$form = $xml->render('params', 'clean_cache_parameters');
				break;
			case 11:
				$form = "Click Apply";
				break;
			case 12:
				$form = "Click Apply";
				break;
		}
	}

	function onToolExecute($name, $id)
	{
		if($name != 'toolset') return;

		global $mainframe;

		$db = &JFactory::getDBO();
		$params = new JParameter('');
		if(@$_POST['params']) $params->loadArray(@$_POST['params']);

		switch ($id)
		{
			case 1:
				$this->cleanSef($params);
				break;
					
			case 4:
				$this->cleanCache($params);
				break;
					
			case 2:
				$this->moveUser($params);
				break;
					
			case 3:
				$this->packSection($params);
				break;
					
			case 5:
				$this->reCalculate($params);
				break;
			case 6:
				$this->cleanSessions($params);
				break;
			case 7:
				$this->archive($params);
				break;
			case 8:
				$this->dbtools($params);
				break;
			case 9:
				$this->migrate($params);
				break;
			case 11:
				$this->migrate2($params);
				break;
			case 12:
				$this->revalidate_fieldsdata($params);
				break;
		}
	}
	
	function revalidate_fieldsdata($params)
	{
		global $mainframe;
	
		$db =& JFactory::getDBO();
	
		$sql = "SELECT id FROM #__js_res_record";
		$db->setQuery($sql);
		$records = $db->loadResultArray();
	
		JArrayHelper::toInteger($records);
	
	
		foreach ($records AS $record)
		{
			$storef = array();
			
			$sql = "SELECT field_id, field_value
			FROM #__js_res_record_values AS v
			WHERE record_id = $record AND field_id IN(SELECT id FROM #__js_res_fields WHERE searchable = 1)";
			$db->setQuery($sql);
			$fields = $db->loadObjectList();
				
			if(count($fields))
			{
				foreach ($fields AS $field)
				{
					$val = @unserialize($field->field_value);
					if(is_array($val))
					{
						$field->field_value = $val;
					}
					$storef[$field->field_id] = $field->field_value;
				}
					
					
				$fieldss = str_replace("'", "\'", serialize($storef));
					
				$sql = "UPDATE  #__js_res_record SET fieldsdata = '{$fieldss}' WHERE id = $record";
				$db->setQuery($sql);
				$db->query();
			}
		}
	
		$mainframe->enqueueMessage(JText::_('Fields Data Revalidating Complete'));
	}

	function migrate2($params)
	{
		global $mainframe;
		
		$db =& JFactory::getDBO();

		$sql = "SELECT id FROM #__js_res_record WHERE categories IS NULL OR (fieldsdata='a:0:{}' OR fieldsdata IS NULL) ";
		$db->setQuery($sql);
		$records = $db->loadResultArray();
		
		JArrayHelper::toInteger($records);
		
		
		foreach ($records AS $record)
		{
			$storef = array();
			$store = array();
			
			$sql = "SELECT d.id, d.name 
			FROM #__js_res_record_category  AS c 
			LEFT JOIN #__js_res_category AS d ON d.id = c.catid
			WHERE c.record_id = $record";
			$db->setQuery($sql);
			$cats = $db->loadObjectList();
			
			foreach ($cats AS $cat)
			{
				$store[$cat->id] = $cat->name;
			}
			
			$sql = "SELECT field_id, field_value 
			FROM #__js_res_record_values AS v
			WHERE record_id = $record AND field_id IN(SELECT id FROM #__js_res_fields WHERE searchable = 1)";
			$db->setQuery($sql);
			$fields = $db->loadObjectList();
			
			
			foreach ($fields AS $field)
			{
				$val = @unserialize($field->field_value);
				if(is_array($val))
				{
					$field->field_value = $val;
				}
				$storef[$field->field_id] = $field->field_value;
			}
			
			
			$categories = serialize($store);
			$fieldss = str_replace("'", "\'", serialize($storef));
			
			$sql = "UPDATE  #__js_res_record SET categories = '{$categories}', fieldsdata = '{$fieldss}' WHERE id = $record";
			$db->setQuery($sql);
			$db->query();
			//print_r($store);
		}
		
		//print_r($records);
		
		$mainframe->enqueueMessage(JText::_('Migration Complete'));
	}
	function migrate($params)
	{
		$folder =  JPath::clean(RES_GENERAL_UPLOAD.DS.'picture');
		if(JFolder::exists($folder))
		{
			$folders = JFolder::folders($folder);
			foreach ($folders AS $f)
			{
				$dest = JPath::clean(RES_GENERAL_UPLOAD.DS.$f.DS.'picture');
				JFolder::copy($folder.DS.$f, $dest, NULL, TRUE);
				JFolder::delete($folder.DS.$f);
			}
			JFolder::delete($folder);
		}
		
		$folder =  JPath::clean(RES_GENERAL_UPLOAD.DS.'file');
		if(JFolder::exists($folder))
		{
			$folders = JFolder::folders($folder);
			foreach ($folders AS $f)
			{
				$dest = JPath::clean(RES_GENERAL_UPLOAD.DS.$f.DS.'file');
				JFolder::copy($folder.DS.$f, $dest, NULL, TRUE);
				JFolder::delete($folder.DS.$f);
			}
			JFolder::delete($folder);
		}
		
		$folder =  JPath::clean(RES_GENERAL_UPLOAD.DS.'audio');
		if(JFolder::exists($folder))
		{
			$folders = JFolder::folders($folder);
			foreach ($folders AS $f)
			{
				$dest = JPath::clean(RES_GENERAL_UPLOAD.DS.$f.DS.'audio');
				JFolder::copy($folder.DS.$f, $dest, NULL, TRUE);
				JFolder::delete($folder.DS.$f);
			}
			JFolder::delete($folder);
		}
		
		$folder =  JPath::clean(RES_GENERAL_UPLOAD.DS.'video');
		if(JFolder::exists($folder))
		{
			$folders = JFolder::folders($folder);
			foreach ($folders AS $f)
			{
				$dest = JPath::clean(RES_GENERAL_UPLOAD.DS.$f.DS.'video');
				JFolder::copy($folder.DS.$f, $dest, NULL, TRUE);
				JFolder::delete($folder.DS.$f);
			}
			JFolder::delete($folder);
		}
	}
	function dbtools($params)
	{
		global $mainframe;
		
		$tables = $params->get('db_tables');
		settype($tables, 'array');
		$table_line = implode(', ', $tables);

		if(!$tables)
		{
			JError::raiseWarning(400, JText::_('No table selected'));
			return;
		}
		$db =& JFactory::getDBO();

		switch ($params->get('db_action'))
		{
			case 1:
				$sql = "OPTIMIZE TABLE ".$table_line;
				$db->setQuery($sql);
				$db->query();
				$mainframe->enqueueMessage(JText::_('Tables Optimized').': '.$table_line);
				break;
			case 2:
				$sql = "REPAIR TABLE ".$table_line;
				$db->setQuery($sql);
				$db->query();
				$mainframe->enqueueMessage(JText::_('Tables Repaired').': '.$table_line);
				break;
			case 3:
				$sql = "ANALYZE TABLE ".$table_line;
				$db->setQuery($sql);
				$mainframe->enqueueMessage(JText::_('Tables Analized'));
				$res = $db->loadObjectList();
				if($res)
				{
					echo '<table class="adminlist"><thead><TR><th>Table</th><th>Op</th><th>Message Type</th><th>Message</th></tr></thead>';
					foreach ($res AS $r)
					{
						echo sprintf('<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>',$r->Table, $r->Op, $r->Msg_type, $r->Msg_text );
					}
					echo '</table><br />';
				}
				break;
			case 5:
				$sql = "CHECK TABLE ".$table_line;
				$db->setQuery($sql);
				$mainframe->enqueueMessage(JText::_('Tables Checked'));
				$res = $db->loadObjectList();
				if($res)
				{
					echo '<table class="adminlist"><thead><TR><th>Table</th><th>Op</th><th>Message Type</th><th>Message</th></tr></thead>';
					foreach ($res AS $r)
					{
						echo sprintf('<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>',$r->Table, $r->Op, $r->Msg_type, $r->Msg_text );
					}
					echo '</table><br />';
				}
				break;
					
			case 4:
				foreach ($tables AS $table)
				{
					$sql = "TRUNCATE TABLE ".$table;
					$db->setQuery($sql);
					$db->query();
					$mainframe->enqueueMessage(JText::_('TRUNCATE Table').': '.$table);
				}
				break;
		}
	}
	function reCalculate($params)
	{
		global $mainframe;
		$db =& JFactory::getDBO();
		if($params->get('comments'))
		{
			//$sql = "UPDATE #__js_res_record r SET r.comments = (SELECT count(*) FROM #__js_res_comments c WHERE c.record_id = r.id)";
			//$db->setQuery($sql);
			//$db->query();
		}
		if($params->get('votes'))
		{
			$sql = "UPDATE #__js_res_record r SET r.votes = (SELECT count(*) FROM #__js_res_vote c WHERE c.record_id = r.id)";
			$db->setQuery($sql);
			$db->query();
		}
		if($params->get('favorites'))
		{
			$sql = "UPDATE #__js_res_record r SET r.favorite_num = (SELECT count(*) FROM #__js_res_favorite c WHERE c.record_id = r.id)";
			$db->setQuery($sql);
			$db->query();
		}
		if($params->get('categories'))
		{
			//$sql = "UPDATE #__js_res_record r SET r.favorite_num = (SELECT count(*) FROM #__js_res_favorite c WHERE c.record_id = r.id)";
			//$db->setQuery($sql);
			//$db->query();
		}
		$mainframe->enqueueMessage(JText::_('Calculated Successfully'));
	}
	function cleanSessions($params)
	{
		global $mainframe;
		$db =& JFactory::getDBO();
		$sql = "DELETE FROM #__session";

		if($params->get('Registered'))
		{
			$where[] = "usertype = ".$db->Quote('Registered');
		}
		if($params->get('Author'))
		{
			$where[] = "usertype = ".$db->Quote('Author');
		}
		if($params->get('Editor'))
		{
			$where[] = "usertype = ".$db->Quote('Editor');
		}
		if($params->get('Publisher'))
		{
			$where[] = "usertype = ".$db->Quote('Publisher');
		}
		if($params->get('Manager'))
		{
			$where[] = "usertype = ".$db->Quote('Manager');
		}
		if($params->get('Administrator'))
		{
			$where[] = "usertype = ".$db->Quote('Administrator');
		}
		if($params->get('Super Administrator'))
		{
			$where[] = "usertype = ".$db->Quote('Super Administrator');
		}

		if(!$where)
		{
			Jerror::raiseWarning(403, JText::_('Please select at least 1 user type'));
			return;
		}

		$sql .= ' WHERE '.implode(" OR ", $where);

		$db->setQuery($sql);
		$db->query();

		$db->setQuery('OPTIMIZE TABLE #__session');
		$db->query();

		$mainframe->enqueueMessage(JText::_('Sessions cleaned Successfully. Affected Rows').' ('.$db->getAffectedRows().')');
	}
	function archive($params)
	{
		global $mainframe;
		if(!$params->get('start_date') || !$params->get('end_date'))
		{
			Jerror::raiseWarning(403, JText::_('Both dates have to be set.'));
			return;
		}
		$db =& JFactory::getDBO();
		$sql =  " UPDATE #__js_res_record SET published = ".$params->get('action');
		$sql .= " WHERE ctime >= '".$params->get('start_date')."' AND  ctime <= '".$params->get('end_date')."'";

		if((int)$params->get('type_id'))
		{
			$sql .= " AND type_id = ".(int)$params->get('type_id');
		}

		$query = "SELECT r.id FROM #__js_res_record AS r
			LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id
			LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid
			WHERE (rc.section_id = %d OR rc.id = %d)
			GROUP BY r.id
		";
		$db->setQuery(sprintf($query, $params->get('section_id'), $params->get('section_id')));
		$array = $db->loadResultArray();
		$ids = implode(',', $array);
		$sql .= " AND id IN ({$ids})";

		$db->setQuery($sql);
		$db->query();
		$mainframe->enqueueMessage(JText::_('Successfully'));
	}
	function packSection($params)
	{
		global $mainframe;
		require_once JPATH_PLUGINS.DS.'joomsuite_content'.DS.'toolset'.DS.'toolset_section.php';

		$pack_helper = new METoolSetPackHelper();

		if($file = $pack_helper->pack($params))
		$mainframe->enqueueMessage(JText::_('Pack Created Successfully'));
		$mainframe->enqueueMessage('joomla_root/administrator/cache/<b>'.JHTML::link('cache/'.$file, $file)).'</b>';
	}

	function moveUser($params)
	{
		if(!$params->get('user_from'))
		{
			JError::raiseWarning(500, JText::_('User ID not defined'));
			break;
		}
		require_once JPATH_PLUGINS.DS.'joomsuite_content'.DS.'toolset'.DS.'toolset_users.php';
		METoolSetUserHelper::execute($params);
	}

	function cleanCache($params)
	{
		global $mainframe;

		$db = &JFactory::getDBO();
		$w = array();

		if($params->get('record')) 	$w[] = "'record'";
		if($params->get('filters')) $w[] = "'filter'";
		if($params->get('ext_filters'))	$w[] = "'ext_filter'";

		if(!$w)
		{
			JError::raiseWarning(500, JText::_('Type not chosen'));
			return;
		}
		if($params->get('period')) 	$date = " AND ctime < CURDATE() - INTERVAL ".$params->get('period')." DAY ";
		if($params->get('section_id')) 	$sec = " AND section = ".$params->get('section_id');


		$sql = "DELETE FROM #__js_res_cache WHERE `type` IN (".implode(', ', $w).') '.@$date.@$sec;
		$db->setQuery($sql);
		$db->query();

		$mainframe->enqueueMessage(JText::_('Cleaned Successfully'));
	}

	function cleanSef($params)
	{
		global $mainframe;

		$db = &JFactory::getDBO();
		$w = array();
		if($params->get('resources')) 	$w[] = "`option` = 'com_resource'";
		if($params->get('touch')) 		$w[] = "`option` = 'com_community'";
		if($params->get('commerce')) 	$w[] = "`option` = 'com_commerce'";

		if(!$w) break;

		$sql = "DELETE FROM #__js_res_sef WHERE (".implode(' OR ', $w).')';
		$db->setQuery($sql);
		$db->query();

		$mainframe->enqueueMessage(JText::_('Cleaned Successfully'));
	}
}