<?php
class METoolSetUserHelper
{
	function execute($params)
	{
		global $mainframe;

		$db =& JFactory::getDBO();
		$from = (int)$params->get('user_from');
		$to = (int)$params->get('user_to');

		if($params->get('clean_events') && METoolSetUserHelper::isTableExists('community_events'))
		{
			$sql = "DELETE FROM #__community_events WHERE user_id = {$from} AND published = 0";
			$db->setQuery($sql);
			$db->query();
		}

		METoolSetUserHelper::cleanTable($params->get('clean_events'), $from, $to, 'community_events');

		METoolSetUserHelper::cleanTable($params->get('clean_activity'), $from, $to, 'community_activity');

		METoolSetUserHelper::cleanTable($params->get('clean_groups'),   $from, $to, 'community_communities');

		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_folders');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_draft');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_history', 'who');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_history', 'whom');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_junk');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_preset_assign');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_presets');
		METoolSetUserHelper::cleanTable($params->get('clean_messages'), $from, $to, 'js_inbox_sent');
		METoolSetUserHelper::copyMessageFiles($params->get('clean_messages'), $from, $to);

		METoolSetUserHelper::cleanTable($params->get('clean_subscr'),   $from, $to, 'jcs_user_subscr');
		METoolSetUserHelper::cleanTable($params->get('clean_subscr'),   $from, $to, 'jcs_coupons_history');
		METoolSetUserHelper::cleanTable($params->get('clean_subscr'),   $from, $to, 'jcs_history');

		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'juser_extended_data');
		METoolSetUserHelper::cleanTable(1, $from, $to, 'community_blocks');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_guests');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_stuffs');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_twitter');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_user_extra');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_user_mapping');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_userrelations', 'user_id');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_userrelations', 'friend_id');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_plg_cv');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_plg_edu');
		METoolSetUserHelper::cleanTable($params->get('clean_profile'), $from, $to, 'community_plg_places');
		METoolSetUserHelper::copyCommunityFiles($params->get('clean_profile'), $from, $to);

		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_coupons', 'seller_id');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_orders');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_orders_statuses', 'seller_id');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_ship_forwarder', 'seller_id');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_taxes', 'seller_id');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_users');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_users_addresses');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_users_balance'); //??? 
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_users_shipping');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_users_currencies', 'seller_id');
		METoolSetUserHelper::cleanTable($params->get('clean_commerce'), $from, $to, 'jc_users_types', 'seller_id');
		METoolSetUserHelper::copyCommerceFiles($params->get('clean_commerce'), $from, $to);

		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_category_user');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_hits');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_favorite');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_comments');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_download_hits');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_polls');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_record');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_tags_history');
		METoolSetUserHelper::cleanTable($params->get('clean_records'), $from, $to, 'js_res_vote');
		METoolSetUserHelper::copyResourcesFiles($params->get('clean_records'), $from, $to);
		
		if($params->get('user_delete'))
		{
			$sql = "DELETE FROM #__users WHERE id = {$from}";
			$db->setQuery($sql);
			$db->query();
		}
		$mainframe->enqueueMessage(JText::_('Successfully'));
	}

	function copyCommerceFiles($action, $from, $to)
	{

	}
	function copyCommunityFiles($action, $from, $to)
	{
		if(!METoolSetUserHelper::isComponentInstalled('com_community')) return;
		if($action == 0) return;
		
		require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community'.DS.'controllers'.DS.'config.php');
		CommunityControllerConfig::initialyze();

		$ini_file = COMMUNITY_GENERAL_UPLOAD.DS.$from.'.ini';
		if(JFile::exists($ini_file)) JFile::delete($ini_file);
	}
	function copyMessageFiles($action, $from, $to)
	{

	}
	function copyResourcesFiles($action, $from, $to)
	{
		if(!METoolSetUserHelper::isComponentInstalled('com_resource')) return;
		if($action == 0) return;
		
		require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();

		//$ini_file = RES_GENERAL_UPLOAD.DS.$from.'.ini';
		//if(JFile::exists($ini_file)) JFile::delete($ini_file);
	}


	function cleanTable($action, $from, $to, $table, $tag = 'user_id')
	{

		if(!METoolSetUserHelper::isTableExists($table)) return;
		if($action == 0) return;

		$db =& JFactory::getDBO();

		if($action == 1)
		$sql = "DELETE FROM #__{$table} WHERE {$tag} = {$from}";
		else
		{
			if(!$to)
			{
				JError::raiseWarning(500, JText::_('New user ID not set to move Items'));
				return;
			}
			$sql = "UPDATE #__{$table} SET {$tag} = {$to} WHERE {$tag} = {$from}";
			
			if($action == 2)
			{
				$sql2 = "DELETE FROM #__{$table} WHERE {$tag} = {$to}";
				$db->setQuery($sql2);
				$db->query();
			}
		}
		$db->setQuery($sql);
		$db->query();
	}
	function isComponentInstalled( $component_name )
	{
		$file_frontend 	= JPATH_SITE.DS."components".DS."com_".$component_name.DS.$component_name.".php";
		$file_backend 	= JPATH_ADMINISTRATOR.DS."components".DS."com_".$component_name.DS.$component_name.".php";
		$file_backend2 	= JPATH_ADMINISTRATOR.DS."components".DS."com_".$component_name.DS."admin.".$component_name.".php";

		if( file_exists($file_frontend) AND (file_exists($file_backend) OR file_exists($file_backend2) ) ) return true;
		return false;
	}

	function isTableExists($table_name)
	{
		$db	=& JFactory::getDBO();
		$config =& JFactory::getConfig();
		$pref = $config->getValue( 'config.dbprefix' );
		$sql = "SHOW TABLES LIKE '{$pref}{$table_name}'";
		$db->setQuery($sql);
		$table = $db->loadResult();
		return $table;
	}
}
?>